package com 
{
	/**
	 * ...
	 * @author 
	 */
	public class LinearInterpolator implements IInterpolator
	{
		private var keyframes : Array;
		public function LinearInterpolator() 
		{
			this.keyframes = new Array;
		}
		
		public function setKeyframes(keyframes:Array):void {
			this.keyframes = keyframes;
		}
		
		public function get(t:Number):Frame {
			if (t < 0) 
				t = 0;
			t = t % (keyframes.length-1);
			var t1:Number = Math.floor(t);
			var f1 : Frame = keyframes[t1];
			var f2 : Frame = keyframes[t1 + 1];
			var f : Frame = new Frame(f1.x, f1.y, f1.r);
			var s : Number = t - t1;
			// poloha sa da interpolovat podla vzorca priamo
			f.x = (1-s)*f1.x + s* f2.x;
			f.y = (1-s)*f1.y + s* f2.y;
			
			// rotacia treba rozlisit ci sa uhly lisia viac ako o 180 stupnov
			var dr:Number = f2.r - f1.r;
			if (dr > Math.PI)
				dr = -2*Math.PI+dr;
			if (dr < -Math.PI)
				dr = 2*Math.PI+dr;
			f.r += dr * (t - t1);	
			return f;
		}
	}

}